import matplotlib.pyplot as plt
import numpy as np
import pandas as pd
import numpy as np

# Toma de datos de planilla Excel
df = pd.read_excel (r'C:\Users\Zeta\Documents\Programacion\Investigacion Operativa\IO Guia 2.7 Tabla_excel_datos.xlsx') #place "r" before the path string to address special character, such as '\'. Don't forget to put the file name at the end of the path + '.xlsx'
# lee los datos de una tabla de excel y los almacena como un dataframe
# print (df)
# print(df.iloc[0,0])

matriz = df.to_numpy()
# convierte el dataframe a un array (se pierden los nombres de las columnas)

# print (matriz)
#print (matriz[:,0])

# Columnas = df.columns.values
# almacena los nombres de las columnas del excel en la lista "Columnas"
# print (Columnas)

#Datos = dict(zip(matriz[:,0], matriz[:,1]))
# crea un diccionario con key = 1er columna de la matriz de datos, y valores de la 2da columna
#print(Datos)

for x,y in zip(matriz[:,0], matriz[:,1]):
    locals()[x] = y
# Crea variables a partir de los nombres en la primer columna de datos y sus respectivos valores

# Resolviendo con PuLP
from pulp import*
#ejs: LpMaximize, LpProblem, LpStatus, lpSum, LpVariable, LpMinimize, value

# Creacion del Modelo
model = LpProblem(name="IO_Ej_Guia_2.6", sense=LpMaximize)

# Inicializacion de Variables de decision
XA1 = LpVariable(name="XA1", lowBound=0)
XA2 = LpVariable(name="XA2", lowBound=0)
XB = LpVariable(name="XB", lowBound=0)


# Introduciendo las restricciones al modelo
model += (1/nAC22/nAC4/nAC21/effAC1*XA1 + 1/nAC3/nAC4/nAC21/effAC1 * XA2 + 1/nBC4/nBC3/effBC1*XB<= 12, "restriccion_1")
model += (1 / effAC22 * XA1 + XA1 * 1 / nAC22/nAC4/effAC21 + XA2 * 1 /nAC4/nAC3/effAC21 <= 12, "restriccion_2")
model += (XA2 * 1 /effAC3 +  XB *  1/nBC4/effBC3 <= 12, "restriccion_3")
model += (XA1 * 1/nAC22/effAC4 + XA2 * 1 /nAC3/effAC4 + XB * 1/effBC4 <= 16, "restriccion_4")
model += (XA1 + XA2 <= 1750, "restriccion_5")
model += (XB <= 1500, "restriccion_6")
model += (XA1 + XA2 + XB <= 2500, "restriccion_7")
model += (XA1 + XA2 >= 600, "restriccion_8")


# Introduciendo la funcion objetivo
model += - XA1*sAC22 - XA1 * 1 /nAC22*sAC4 - XA1 * 1/nAC22/nAC4*sAC21 - XA1 * 1/nAC22/nAC4/nAC21*sAC1 - (1/nAC1/nAC21/nAC4/nAC22-1)*50 - XA2*sAC3 - XA2 * 1/nAC3*sAC4 - XA2 * 1/nAC4/nAC3*sAC21 - XA2 * 1/nAC21/nAC3/nAC4*sAC1 - (1/nAC3/nAC4/nAC21/nAC1-1)*50 - XB*sBC4 - XB * 1/nBC4*sBC3 - XB * 1/nBC3/nBC4*sBC1 - (1/nBC4/nBC3/nBC1 - 1)* 60 + XA1 * 60 + XA2 * 60 + XB * 180


# Llamado a la solucion del problema
status = model.solve()

print(model)

# Impresion de resultados
print(f"status: {model.status}, {LpStatus[model.status]}")
print("Valor Optimo del Funcional:")
print(f"objective: {model.objective.value()}")

for var in model.variables():
    print(f"{var.name}: {var.value()}")

for name, constraint in model.constraints.items():
    print(f"{name}: {constraint.value()}")
    if constraint.value() <= 0:
        print("(representa un sobrante del recurso no utilizado)")
    elif constraint.value() >= 0:
        print("(representa un excedente sobre la restriccion de minimo planteado)")